// Generated by dts-bundle-generator v9.5.1

export declare class SocketError extends Error {
	name: string;
	originalError?: Error | ErrorEvent;
	constructor(message: string, originalError?: Error | ErrorEvent);
}
export declare class UnpackError extends SocketError {
}
export declare const Heartbeat: unique symbol;
export interface DataMessage {
	_: unknown;
}
export declare function pack(data: unknown): string;
/**
 * Returns the data in the message or the Heartbeat symbol
 *
 * @param data - The JSON string to be deserialized.
 * @returns The deserialized data or the Heartbeat symbol
 * @throws {ManagedSocketError} If the JSON string cannot be parsed or if the message shape is invalid.
 */
export declare function unpack(data: string): {
	data: unknown;
} | typeof Heartbeat;
export type SocketDataHandler = (data: unknown) => void | Promise<void>;
export type SocketErrorHandler = (error: SocketError) => void;
export type SocketConnectedHandler = () => void;
export type SocketDisconnectedHandler = ({ wasClean, code, reason, }: {
	wasClean: boolean;
	code: number;
	reason: string;
}) => void;
export interface HandlerDefinitions {
	onMessage?: SocketDataHandler;
	onError?: SocketErrorHandler;
	onConnected?: SocketConnectedHandler;
	onDisconnected?: SocketDisconnectedHandler;
}
export declare class ManagedSocket {
	readonly url: string;
	socket: WebSocket;
	onMessage: SocketDataHandler;
	onError: SocketErrorHandler;
	onConnected: SocketConnectedHandler;
	onDisconnected: SocketDisconnectedHandler;
	private _reconnectAttempts;
	private _messageQueue;
	private _debugMode;
	private _offline;
	constructor(url: string, handlers?: HandlerDefinitions);
	private sendHeartbeat;
	private debugMessage;
	private sendQueuedMessages;
	private attemptReconnection;
	private connect;
	get isConnected(): boolean;
	debug(debugModeEnabled: boolean): void;
	close(): void;
	send(data: unknown): void;
}

export {};
